//+------------------------------------------------------------------+
//|                                        AbsoluteStrength_v1.1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   4
#property indicator_color1    Blue
#property indicator_color2    Red
#property indicator_color3    Aqua
#property indicator_color4    Orange
#property indicator_width1    2
#property indicator_width2    2
#property indicator_width3    2
#property indicator_width4    2

//---- input parameters
extern string    _          = "parameters";
extern int       Mode       =  0; // 0-RSI method; 1-Stoch method; 2-ADX method
extern int       Length     = 30; // Period of evaluation
extern int       Smooth     =  5; // Period of smoothing
extern int       Signal     =  5; // Period of Signal Line
extern int       Price      =  0; // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int       ModeMA     =  3; // Mode of Moving Average
extern double    OverBought =  0; // OverBought Level
extern double    OverSold   =  0; // OverSold Level 
extern int       ForBar     =  1;
  
double Bulls[];
double Bears[];
double AvgBulls[];
double AvgBears[];
double SmthBulls[];
double SmthBears[];
double SigBulls[];
double SigBears[];
string indicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,SmthBulls);
   SetIndexBuffer(1,SmthBears);
   SetIndexBuffer(2,SigBulls);
   SetIndexBuffer(3,SigBears);
   SetIndexBuffer(4,Bulls);
   SetIndexBuffer(5,Bears);
   SetIndexBuffer(6,AvgBulls);
   SetIndexBuffer(7,AvgBears);
   if(_!="calc")
   {
      IndicatorShortName("AbsoluteStrength("+Mode+","+Length+","+Smooth+","+Signal+",,"+ModeMA+")");
      SetIndexLabel(0,"Bulls");
      SetIndexLabel(1,"Bears");
      SetIndexLabel(2,"SignalBulls");
      SetIndexLabel(3,"SignalBears");      

      SetIndexDrawBegin(0,Length+Smooth+Signal);
      SetIndexDrawBegin(1,Length+Smooth+Signal);
      SetIndexDrawBegin(2,Length+Smooth+Signal);
      SetIndexDrawBegin(3,Length+Smooth+Signal);
   }
   else
   {
      SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,116);
      SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,116);
      SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,116);
      SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,116);
   }      
   indicatorFileName = WindowExpertName();   
   return(0);
}

//
//
//
//
//

int start()
{
   int      shift,limit,counted_bars=IndicatorCounted();
   double   Price1, Price2;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //

   if (_=="calc")
   {
      for( shift=limit; shift>=0; shift--)
      {
         Price1 = iMA(NULL,0,1,0,MODE_SMA,Price,shift);
         Price2 = iMA(NULL,0,1,0,MODE_SMA,Price,shift+1); 
         
         if (Mode==0)
         {
            Bulls[shift] = 0.5*(MathAbs(Price1-Price2)+(Price1-Price2));
            Bears[shift] = 0.5*(MathAbs(Price1-Price2)-(Price1-Price2));
            continue;
         }
         if (Mode==1)
         {
            Bulls[shift] = Price1 - Low[Lowest(NULL,0,MODE_LOW,Length,shift)];
            Bears[shift] = High[Highest(NULL,0,MODE_HIGH,Length,shift)] - Price1;
            continue;
         }
         if (Mode==2)
         {
            Bulls[shift] = 0.5*(MathAbs(High[shift]-High[shift+1])+(High[shift]-High[shift+1]));
            Bears[shift] = 0.5*(MathAbs(Low[shift+1]-Low[shift])+(Low[shift+1]-Low[shift]));
         }
      }

      //
      //
      //
      //
      //
         
      for( shift=limit; shift>=0; shift--)
      {
         AvgBulls[shift]=iMAOnArray(Bulls,0,Length,0,ModeMA,shift);     
         AvgBears[shift]=iMAOnArray(Bears,0,Length,0,ModeMA,shift);
      }
      for( shift=limit; shift>=0; shift--)
      {
         SmthBulls[shift]=iMAOnArray(AvgBulls,0,Smooth,0,ModeMA,shift);     
         SmthBears[shift]=iMAOnArray(AvgBears,0,Smooth,0,ModeMA,shift);
      }
      for( shift=limit; shift>=0; shift--)
      {
         if (OverBought > 0 && OverSold > 0 )
         {
            SigBulls[shift]=OverBought/100.00*(SmthBulls[shift]+SmthBears[shift]);
            SigBears[shift]=OverSold  /100.00*(SmthBulls[shift]+SmthBears[shift]);
         }
         else
         {
            SigBulls[shift]=iMAOnArray(SmthBulls,0,Signal,0,ModeMA,shift);     
            SigBears[shift]=iMAOnArray(SmthBears,0,Signal,0,ModeMA,shift);
         }
      }
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   for( shift=limit; shift>=0; shift--)
   {
         double mainBulls = iCustom(NULL,0,indicatorFileName,"calc",Mode,Length,Smooth,Signal,Price,ModeMA,OverBought,OverSold,0,shift);
         double signBulls = iCustom(NULL,0,indicatorFileName,"calc",Mode,Length,Smooth,Signal,Price,ModeMA,OverBought,OverSold,2,shift);
         double mainBears = iCustom(NULL,0,indicatorFileName,"calc",Mode,Length,Smooth,Signal,Price,ModeMA,OverBought,OverSold,1,shift);
         double signBears = iCustom(NULL,0,indicatorFileName,"calc",Mode,Length,Smooth,Signal,Price,ModeMA,OverBought,OverSold,3,shift);

            SmthBulls[shift] = EMPTY_VALUE;
            SmthBears[shift] = EMPTY_VALUE;
            SigBulls[shift]  = EMPTY_VALUE;
            SigBears[shift]  = EMPTY_VALUE;
 
            if (mainBulls>signBulls && mainBears<signBears && mainBulls>signBears && signBulls>signBears) SmthBulls[shift]=1;
            if (mainBulls<signBulls && mainBears>signBears && mainBulls<mainBears && signBulls<mainBears) SmthBears[shift]=2;
            if (mainBulls>signBulls && mainBears>signBears)                                               SigBulls[shift] =3;
            if (mainBulls<signBulls && mainBears<signBears)                                               SigBears[shift] =4;
   }   
   return(0);
}

